//
//  VCSModelesslViewController.swift
//  ViewControllerSikenjo
//
//  Created by narita on 2018/12/11.
//  Copyright © 2018 narita. All rights reserved.
//

import Cocoa

class VCSModelesslViewController: NSViewController
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods

    override func viewDidLoad()
    {
        super.viewDidLoad()
    }

    // MARK: - action methods
    
    
    // MARK: - event handling methods

    override func prepare(for segue: NSStoryboardSegue, sender: Any?)
    {
        // インスペクターへ表示すべきデータを渡す
        if segue.identifier == "embededModeless"
        {
            if let theVC = segue.destinationViewController as! VCSInspectorViewController?
            {
                theVC.objectController?.bind(.content,
                                             to: self,
                                             withKeyPath: "model.title",
                                             options: nil)
            }
        }
    }
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    override var representedObject: Any?
    {
        didSet
        {
            if let thePVC = self.representedObject as? VCSPresentViewController
            {
                self.selectionObservation = thePVC.arrayController!.observe( \.selection , options: [] )
                {
                    _,_ in
                    
                    if let theObject = thePVC.arrayController!.selection as? NSObject
                    {
                        self.model = NSMutableDictionary(dictionary:
                            [
                                "title" : theObject.value(forKey: "title")!,
                                "memo" : theObject.value(forKey: "memo")!,
                             ])
                    }
                }
            }
        }
    }
    
    @objc var model: Any? = nil
    
    @objc var selectionObservation: NSKeyValueObservation? = nil

    // MARK: - Utility methods
}
